#import "data/scripts/library/spawn.h"
#import "data/scripts/library/basic.h"

void keyint(void Ani, int Frame, void Key, int Hflag)
{// Change current animation if proper key is pressed or released
// Animation is changed to attack mode

    void self = getlocalvar("self");
    int Dir = getentityproperty(self, "direction");
    int iPIndex = getentityproperty(self,"playerindex"); //Get player index
    void iRKey;

      if (Key=="U"){ //Up Required?
        iRKey = playerkeys(iPIndex, 0, "moveup"); // "Up"
      } else if (Key=="D"){ //Down Required?
        iRKey = playerkeys(iPIndex, 0, "movedown"); // "Down"
      } else if (Key=="L"){ //Left Required?
        iRKey = playerkeys(iPIndex, 0, "moveleft"); // "Left"
      } else if (Key=="R"){ //Right Required?
        iRKey = playerkeys(iPIndex, 0, "moveright"); // "Right"
      } else if (Key=="F"){ //Forward Required?
        if (Dir == 0){ // Facing Left?
          iRKey = playerkeys(iPIndex, 0, "moveleft"); // "Left"
        } else { // Facing Right
          iRKey = playerkeys(iPIndex, 0, "moveright"); // "Right"
        }
      } else if (Key=="B"){ //Backward Required?
        if (Dir == 1){ // Facing Right?
          iRKey = playerkeys(iPIndex, 0, "moveleft"); // "Left"
        } else { // Facing Left
          iRKey = playerkeys(iPIndex, 0, "moveright"); // "Right"
        }
      } else if (Key=="J"){ //Jump Required?
        iRKey = playerkeys(iPIndex, 0, "jump"); // "Jump"
      } else if (Key=="A"){ //Attack Required?
        iRKey = playerkeys(iPIndex, 0, "attack"); // "Attack"
      } else if (Key=="A2"){ //Attack Required?
        iRKey = playerkeys(iPIndex, 0, "attack2"); // "Attack2"
      } else if (Key=="S"){ //Special Required?
        iRKey = playerkeys(iPIndex, 0, "special"); // "Special"
      }

      if (Hflag==1){ //Not holding the button case?
        iRKey = !iRKey; //Take the opposite condition
      }

      if (iRKey){
        if (Ani=="ANI_IDLE"){ // Going idle?
          setidle(self, openborconstant("ANI_IDLE")); //Be idle!
        } else {
          performattack(self, openborconstant(Ani)); //Change the animation
        }
        updateframe(self, Frame); //Change frame
      }
}

void keymove(float Vx)
{// Move hero if direction button is pressed
      void self = getlocalvar("self");
      int iPIndex = getentityproperty(self,"playerindex"); //Get player index
	float xdir = 0;

      if (playerkeys(iPIndex, 0, "moveleft")){// Left is pressed?
	  xdir = -Vx;
	} else if(playerkeys(iPIndex, 0, "moveright")){// Right is pressed?
	  xdir = Vx;
      }

	changeentityproperty(self, "velocity", xdir);
}

void PlayMap()
{// Use map defined on level
    void self = getlocalvar("self");
    int PIndex = getentityproperty(self,"playerindex") + 1; //Get player index + 1
    int Remap = getglobalvar("PMap" + PIndex);

    if(Remap != NULL()){
      changeentityproperty(self, "map", Remap);
    }
}

void StartWeap()
{// Starts with weapon if certain variable is set
    void self = getlocalvar("self");
    int PIndex = getentityproperty(self,"playerindex") + 1; //Get player index + 1
    int Drop = getglobalvar("WDrop" + PIndex);

    if(Drop != NULL()){
      changeplayerproperty(PIndex-1, "weapon", Drop);
    }
}

void dropWeap(int dx, int dy, int dz)
{// Drops weapon when drop variable is set
// Used to drop weapon when weapon mode is set from level instead
    void self = getlocalvar("self");
    int PIndex = getentityproperty(self,"playerindex") + 1; //Get player index + 1
    int Drop = getglobalvar("WDrop" + PIndex);
    char Senjat = Weaper(Drop);

    if(Drop != NULL()){
      spawn01(Senjat, dx, dy, dz);
      setglobalvar("WDrop" + PIndex, NULL());
    }
}

void Weaper(int Code)
{// Chooses weapon based on defined code
    if(Code==1){
      return "Nunchaku";
    } else if(Code==2){
      return "Tonfa";
    } else if(Code==3){
      return "Tanto";
    } else if(Code==4){
      return "Katana";
    } else if(Code==5){
      return "Shuko";
    } else if(Code==6){
      return "Bo";
    } else if(Code==7){
      return "Kusari";
    } else if(Code==8){
      return "Tetsubo";
    } else if(Code==9){
      return "Shuriken";
    } else if(Code==10){
      return "Hankyu";
    }
}


void spawnM(void Name, float dx, float dy, float dz)
{ // Spawn certain entity and matches its map with own's map
   void self = getlocalvar("self");
   int map = getentityproperty(self,"map");
   void Spawn;

   Spawn = spawn01(Name, dx, dy, dz);
   changeentityproperty(Spawn, "map", map);
}

void bbounce(void Ani){
	// Check altitude. If projectile is on ground, change animation!
    void self = getlocalvar("self"); // Get self
    int x = getentityproperty(self,"x"); // Get self x pos
    int z = getentityproperty(self,"z"); // Get self z pos
    int y = getentityproperty(self,"a"); // Get self altitude
    int H = checkhole(x,z,y-100); // Checkhole

    if( y <= 1 && H != 1)
	{ // On ground but not on hole?
      changeentityproperty(self, "animation", openborconstant(Ani));
	  // Change to desired animation
    }
}